## NonHaltingDiagnostic

# Enum NonHaltingDiagnostic

Source

    pub enum NonHaltingDiagnostic {
    Show 14 variants    CreatedPointerTag(NonZero<u64>, Option<String>, Option<(AllocId, AllocRange, ProvenanceExtra)>),
        PoppedPointerTag(Item, String),
        CreatedAlloc(AllocId, Size, Align, MemoryKind),
        FreedAlloc(AllocId),
        AccessedAlloc(AllocId, AccessKind),
        RejectedIsolatedOp(String),
        ProgressReport {
            block_count: u64,
        },
        Int2Ptr {
            details: bool,
        },
        NativeCallSharedMem {
            tracing: bool,
        },
        NativeCallFnPtr,
        WeakMemoryOutdatedLoad {
            ptr: Pointer,
        },
        ExternTypeReborrow,
        GenmcCompareExchangeWeak,
        GenmcCompareExchangeOrderingMismatch {
            success_ordering: AtomicRwOrd,
            upgraded_success_ordering: AtomicRwOrd,
            failure_ordering: AtomicReadOrd,
            effective_failure_ordering: AtomicReadOrd,
        },
    }

Expand description

Miri specific diagnostics

## Variants§

§

### CreatedPointerTag(NonZero<u64>, Option<String>, Option<(AllocId, AllocRange, ProvenanceExtra)>)

(new_tag, new_perm, (alloc_id, base_offset, orig_tag))

new_perm is `None` for base tags.

§

### PoppedPointerTag(Item, String)

This `Item` was popped from the borrow stack. The string explains the reason.

§

### CreatedAlloc(AllocId, Size, Align, MemoryKind)

§

### FreedAlloc(AllocId)

§

### AccessedAlloc(AllocId, AccessKind)

§

### RejectedIsolatedOp(String)

§

### ProgressReport

#### Fields

§`block_count: u64`
§

### Int2Ptr

#### Fields

§`details: bool`
§

### NativeCallSharedMem

#### Fields

§`tracing: bool`
§

### NativeCallFnPtr

§

### WeakMemoryOutdatedLoad

#### Fields

§`ptr: Pointer`
§

### ExternTypeReborrow

§

### GenmcCompareExchangeWeak

§

### GenmcCompareExchangeOrderingMismatch

#### Fields

§`success_ordering: AtomicRwOrd`
§`upgraded_success_ordering: AtomicRwOrd`
§`failure_ordering: AtomicReadOrd`
§`effective_failure_ordering: AtomicReadOrd`

## Auto Trait Implementations§

§

### impl Freeze for NonHaltingDiagnostic

§

### impl RefUnwindSafe for NonHaltingDiagnostic

§

### impl Send for NonHaltingDiagnostic

§

### impl Sync for NonHaltingDiagnostic

§

### impl Unpin for NonHaltingDiagnostic

§

### impl UnwindSafe for NonHaltingDiagnostic

## Blanket Implementations§

Source§

### impl<T> Any for T
where T: 'static + ?Sized,

Source§

#### fn type_id(&self) -> TypeId

Gets the `TypeId` of `self`. Read more
Source§

### impl<T> Borrow<T> for T
where T: ?Sized,

Source§

#### fn borrow(&self) -> &T

Immutably borrows from an owned value. Read more
Source§

### impl<T> BorrowMut<T> for T
where T: ?Sized,

Source§

#### fn borrow_mut(&mut self) -> &mut T

Mutably borrows from an owned value. Read more
Source§

### impl<T> From<T> for T

Source§

#### fn from(t: T) -> T

Returns the argument unchanged.

Source§

### impl<T, U> Into<U> for T
where U: From<T>,

Source§

#### fn into(self) -> U

Calls `U::from(self)`.

That is, this conversion is whatever the implementation of `From<T> for U` chooses to do.

Source§

### impl<T> Same for T

Source§

#### type Output = T

Should always be `Self`
Source§

### impl<T, U> TryFrom<U> for T
where U: Into<T>,

Source§

#### type Error = Infallible

The type returned in the event of a conversion error.
Source§

#### fn try_from(value: U) -> Result<T, <T as TryFrom<U>>::Error>

Performs the conversion.
Source§

### impl<T, U> TryInto<U> for T
where U: TryFrom<T>,

Source§

#### type Error = <U as TryFrom<T>>::Error

The type returned in the event of a conversion error.
Source§

#### fn try_into(self) -> Result<U, <U as TryFrom<T>>::Error>

Performs the conversion.
§

### impl<V, T> VZip<V> for T
where V: MultiLane<T>,

§

#### fn vzip(self) -> V

## Layout§

Note: Most layout information is completely unstable and may even differ between compilations. The only exception is types with certain `repr(...)` attributes. Please see the Rust Reference's “Type Layout” chapter for details on type layout guarantees.

Size: 64 bytes

Size for each variant:

- `CreatedPointerTag`: 64 bytes
- `PoppedPointerTag`: 40 bytes
- `CreatedAlloc`: 32 bytes
- `FreedAlloc`: 16 bytes
- `AccessedAlloc`: 24 bytes
- `RejectedIsolatedOp`: 32 bytes
- `ProgressReport`: 16 bytes
- `Int2Ptr`: 9 bytes
- `NativeCallSharedMem`: 9 bytes
- `NativeCallFnPtr`: 0 bytes
- `WeakMemoryOutdatedLoad`: 40 bytes
- `ExternTypeReborrow`: 0 bytes
- `GenmcCompareExchangeWeak`: 0 bytes
- `GenmcCompareExchangeOrderingMismatch`: 12 bytes